# -*- coding: utf-8 -*-
"""
Created on Mon May 20 14:29:26 2019

@author: zchen44
"""

import numpy as np
import pandas as pd 
from decimal import Decimal
from scipy.stats import genpareto
import matplotlib.pyplot as plt


discharge = pd.read_csv("discharge.csv",header=0,index_col=None)
discharge['t']= pd.to_datetime(discharge['t'])

myFile = np.genfromtxt('4.5.csv', delimiter=',')
rcp = myFile.ravel(order='F')

thr = 2.13

duration =25


closure_freq =[]
river_flood_event = []
river_flood_freq  = []

river_flood_gpd25_prob  = []
river_flood_gpd25_elev  = []
river_flood_gpd25_rp = []

river_flood_gpd2_13_prob  = []
river_flood_gpd2_13_elev  = []
river_flood_gpd2_13_rp  = []

for i in range(len(rcp)):
    
    a =thr - rcp[i]
    thr_num = Decimal(a).quantize(Decimal("0.00"))
    thr_str = str(thr_num)



    now = pd.read_csv("dur_freq/"+thr_str+".csv",header=0,index_col=None)
    now['t']= pd.to_datetime(now['t'])
    
    index_min = discharge['t'][0]
    i_min=pd.to_datetime(index_min)
    index_max = discharge['t'][211080] 
    i_max=pd.to_datetime(index_max) 
    extract = (now.t>=i_min)&(now.t<=i_max)
    now_table=now[extract]  
    
    now_table= now_table.reset_index(drop=True)
    

    dis =[]
    
    
    for index in range(len(now_table)):
        t_max = now_table.t[index] + pd.Timedelta('3H') + (now_table.tide_cyc[index]-now_table.peak_num[index])*pd.Timedelta('12H')
        t_min = now_table.t[index] - pd.Timedelta('3H') - (now_table.peak_num[index] -1)*pd.Timedelta('12H')

        
        extract = (discharge.t>=t_min)&(discharge.t<t_max)
        discharge_tep=discharge[extract]  
        dis.append((3600*3.02*10**(-9)*discharge_tep.total.sum())+0.0896-0.063+rcp[i])

    river_flood=(np.asarray(dis)).ravel()
    
    closure_freq.append(len(river_flood)/duration)
    river_flood_event.append(len(river_flood[river_flood>=thr]))
    river_flood_freq.append(len(river_flood[river_flood>=thr])/duration)
    
    if len(river_flood[river_flood>=thr])>=10:
        peak_descend = np.sort(river_flood[river_flood>=thr])[::-1]
        paramEsts= genpareto.fit(peak_descend, floc=thr)
        K=paramEsts[0]
        SIGMA=paramEsts[2]
       
        oCDF=1-genpareto.cdf(thr,K,loc=thr,scale=SIGMA)
        oCDF=oCDF*(len(river_flood[river_flood>=thr])/duration)
        
        river_flood_gpd2_13_prob.append(oCDF)
        river_flood_gpd2_13_rp.append(1/oCDF)
        
        
        x = np.arange(0.01,1,0.01)
        ku = len(river_flood[river_flood>=thr])/duration
        mod_rl = thr + (SIGMA/K)*((ku/x)**K-1)
        mod_rp = 1/x
        
        river_flood_gpd2_13_elev.append(mod_rl[9])
        
        
        b = 0.44
        emp_rp = 1/(np.arange(1-b,len(river_flood[river_flood>=thr])+1-b,1)/(duration+1-2*b))
        
        fig, ax = plt.subplots()
        plt.xlim(1,100)
        ax.set_xscale('log')
        ax.set_xticks([1, 10, 100])
        ax.set_xticklabels(['1',' 10', '100'])
        
        plt.plot(mod_rp,mod_rl,'r-')
        plt.plot(emp_rp,peak_descend,'bo')

        plt.xlabel('RETURN PERIOD (yrs)')
        plt.ylabel('trapped river water elevation (m NAVD88)')
        plt.savefig(str(i)+'_'+str(rcp[i])+'_gpd2_13.png')    
        plt.close()
    
    else: 
        river_flood_gpd2_13_prob.append(np.nan)
        river_flood_gpd2_13_elev.append(np.nan)
        river_flood_gpd2_13_rp.append(np.nan)



    if len(river_flood)>=25:
        peak_descend = np.sort(river_flood)[::-1]
        THETAtc = peak_descend[duration-1]
        peak_top = peak_descend[peak_descend>=THETAtc]  
        paramEsts= genpareto.fit(peak_top, floc=THETAtc)

        K=paramEsts[0]
        SIGMA=paramEsts[2]
       
        oCDF=1-genpareto.cdf(thr,K,loc=THETAtc,scale=SIGMA)
        oCDF=oCDF*(len(peak_top)/duration)
        
        river_flood_gpd25_prob.append(oCDF)
        river_flood_gpd25_rp.append(1/oCDF)
        
        
        x = np.arange(0.01,1,0.01)
        ku = len(peak_top)/duration
        mod_rl = THETAtc + (SIGMA/K)*((ku/x)**K-1)
        mod_rp = 1/x
        
        river_flood_gpd25_elev.append(mod_rl[9])
        
        
        b = 0.44
        emp_rp = 1/(np.arange(1-b,len(peak_top)+1-b,1)/(duration+1-2*b))
        
        fig, ax = plt.subplots()
        plt.xlim(1,100)
        ax.set_xscale('log')
        ax.set_xticks([1, 10, 100])
        ax.set_xticklabels(['1',' 10', '100'])
        
        plt.plot(mod_rp,mod_rl,'r-')
        plt.plot(emp_rp,peak_top,'bo')
        plt.xlabel('RETURN PERIOD (yrs)')
        plt.ylabel('trapped river water elevation (m NAVD88)')
        plt.savefig(str(i)+'_'+str(rcp[i])+'_gpd25.png')    
        plt.close()
    
    else: 
        river_flood_gpd25_prob.append(np.nan)
        river_flood_gpd25_elev.append(np.nan)
        river_flood_gpd25_rp.append(np.nan)






closure_freq =  (np.asarray(closure_freq)).ravel()
river_flood_event =  (np.asarray(river_flood_event)).ravel()
river_flood_freq =  (np.asarray(river_flood_freq)).ravel()



river_flood_gpd25_prob  = (np.asarray(river_flood_gpd25_prob)).ravel()
river_flood_gpd25_elev  = (np.asarray(river_flood_gpd25_elev)).ravel()
river_flood_gpd25_rp = (np.asarray(river_flood_gpd25_rp)).ravel()

river_flood_gpd2_13_prob  = (np.asarray(river_flood_gpd2_13_prob)).ravel()
river_flood_gpd2_13_elev  = (np.asarray(river_flood_gpd2_13_elev)).ravel()
river_flood_gpd2_13_rp  = (np.asarray(river_flood_gpd2_13_rp)).ravel()


all_table = pd.DataFrame({ 'closure_freq':closure_freq, 'river_flood_event':river_flood_event, 'river_flood_freq':river_flood_freq,'river_flood_gpd25_prob':river_flood_gpd25_prob,'river_flood_gpd25_rp':river_flood_gpd25_rp,'river_flood_gpd25_elev':river_flood_gpd25_elev, 'river_flood_gpd2_13_prob':river_flood_gpd2_13_prob, 'river_flood_gpd2_13_rp':river_flood_gpd2_13_rp, 'river_flood_gpd2_13_elev':river_flood_gpd2_13_elev })
all_table.to_csv('eva_results.csv') 
